## vqmt-dmo 1.1.25.g640a3a8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)

# project information
project(vqmt CXX)
set(WEBSITE "http:/mmspg.epfl.ch/vqmt")
set(COPYRIGHT "(c) 2013 Philippe Hanhart")
set(DESCRIPTION "Compute PSNR, SSIM, MS-SSIM, VIFp, PSNR-HVS and PSNR-HVS-M metrics between raw YUV videos using OpenCV")

set(PACKAGE ${CMAKE_PROJECT_NAME})
set(VERSION_MAJOR 1)
set(VERSION_MINOR 1)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR})

# useful defines
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)
set(SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(BUILD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/build)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY bin/${CMAKE_BUILD_TYPE})

# defines for installation

# installation prefix
if(DEFINED PREFIX)
	set(PREFIX ${PREFIX} CACHE PATH "install prefix")
	set(CMAKE_INSTALL_PREFIX ${PREFIX})
else()
	set(PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "install prefix")
endif()
mark_as_advanced(CMAKE_INSTALL_PREFIX)

# share directory
if(DEFINED SHAREDIR)
	set(SHAREDIR ${SHAREDIR} CACHE PATH "share directory")
else()
	set(SHAREDIR ${PREFIX}/share CACHE PATH "share directory")
endif()

# man path
# TODO uncomment the following once a manpage has been written
#if(DEFINED MAN_PATH)
#	set(MAN_PATH ${MAN_PATH} CACHE PATH "manpage directory")
#else()
#	set(MAN_PATH ${SHAREDIR}/man CACHE PATH "manpage directory")
#endif()

# documentation path
if(DEFINED DOC_PATH)
    set(VQMT_DOC_PATH ${DFC_DOC_PATH} CACHE PATH "doc directory")
else()
    set(VQMT_DOC_PATH ${SHAREDIR}/doc/${PACKAGE} CACHE PATH "doc directory")
endif()

# set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wdouble-promotion HAS_DOUBLE_PROMOTION)
check_cxx_compiler_flag(-Wsuggest-attribute=const HAS_SUGGEST_ATTRIBUTE_CONST)
check_cxx_compiler_flag(-Wsuggest-attribute=noreturn HAS_SUGGEST_ATTRIBUTE_NORETURN)
check_cxx_compiler_flag(-Wuseless-cast HAS_USELESS_CAST)
check_cxx_compiler_flag(-Wlogical-op HAS_LOGICAL_OP)
check_cxx_compiler_flag(-Wstrict-null-sentinel HAS_STRICT_NULL_SENTINEL)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Wformat=2 -Winit-self -Wmissing-include-dirs -Wswitch-default -Wfloat-equal -Wundef -Wshadow -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wsign-conversion  -Wmissing-declarations -Wredundant-decls -Wnon-virtual-dtor -Wold-style-cast -Woverloaded-virtual -pipe")

if(HAS_DOUBLE_PROMOTION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wdouble-promotion")
endif()
if(HAS_SUGGEST_ATTRIBUTE_CONST)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-attribute=const")
endif()
if(HAS_SUGGEST_ATTRIBUTE_NORETURN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-attribute=noreturn")
endif()
if(HAS_USELESS_CAST)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wuseless-cast")
endif()
if(HAS_LOGICAL_OP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
endif()
if(HAS_STRICT_NULL_SENTINEL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wstrict-null-sentinel")
endif()

set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -O3 -flto -DNDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS} -g3 -ggdb3 -Wpadded -Wpacked")

find_package(OpenCV REQUIRED)
set(EXECUTABLE_NAME ${CMAKE_PROJECT_NAME})
set(SRCS
    ${SOURCE_DIR}/main.cpp
    ${SOURCE_DIR}/Metric.cpp
    ${SOURCE_DIR}/MSSSIM.cpp
    ${SOURCE_DIR}/PSNR.cpp
    ${SOURCE_DIR}/PSNRHVS.cpp
    ${SOURCE_DIR}/SSIM.cpp
    ${SOURCE_DIR}/VideoYUV.cpp
    ${SOURCE_DIR}/VIFP.cpp
)
add_executable(
    ${EXECUTABLE_NAME}
    ${SRCS}
)
target_link_libraries(${CMAKE_PROJECT_NAME} ${OpenCV_LIBS})

set(VQMT_DOC_FILES
	AUTHORS.md
    CHANGELOG.md
	LICENSE
	README.md
    readme.txt
)

# rule to generate a source tarball
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
set(CPACK_SOURCE_IGNORE_FILES
	"~$"
    ".directory"
	".swp$"
	"^${PROJECT_SOURCE_DIR}/.git/"
	"^${PROJECT_SOURCE_DIR}/build/"
	"${PROJECT_SOURCE_DIR}/.gitignore$"
	"${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)
add_custom_target(dist
	COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

# installation
install(TARGETS ${EXECUTABLE_NAME} RUNTIME DESTINATION bin)
# TODO uncomment the following once the manpage has been written
#install(FILES ${MAN_DIR}/vqmt.1 DESTINATION ${MAN_PATH}/man1)
install(FILES ${VQMT_DOC_FILES} DESTINATION ${VQMT_DOC_PATH})

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P
	${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== Makefile ===
all:
	test -d build || mkdir build
	cd build && cmake -DCMAKE_BUILD_TYPE=Release .. && make

debug:
	test -d build || mkdir build
	cd build && cmake -DCMAKE_BUILD_TYPE=Debug .. && make

clean:
	rm -rf build

.PHONY: all debug clean

=== debian/changelog ===
vqmt-dmo (1:1.1.25.g640a3a8-dmo3) unstable; urgency=medium

  * Build with opencv 4.6.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Jul 2022 07:32:59 +0200

vqmt-dmo (1:1.1.25.g640a3a8-dmo2) unstable; urgency=medium

  * Build with opencv 4.5d

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 26 Nov 2021 08:52:25 +0100

vqmt-dmo (1:1.1.25.g640a3a8-dmo1) unstable; urgency=medium

  * Update package version with the version provided by git describe.
  * Fix build for aches other than amd64/i386

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 06 May 2021 14:26:42 +0200

vqmt-dmo (1.1.git640a3a8-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 06 May 2021 11:30:25 +0200

=== debian/control ===
Source: vqmt-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://www.epfl.ch/labs/mmspg/downloads/vqmt/
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 13), cmake, libopencv-dev, ninja-build,
 quilt

Package: vqmt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Video Quality Measurement Tool.
 This software provides fast implementations of the following objective
 metrics:
 .
  *  PSNR: Peak Signal-to-Noise Ratio,
  *  SSIM: Structural Similarity,
  *  MS-SSIM: Multi-Scale Structural Similarity,
  *  VIFp: Visual Information Fidelity, pixel domain version,
  *  PSNR-HVS: Peak Signal-to-Noise Ratio taking into account Contrast
     Sensitivity Function (CSF),
  *  PSNR-HVS-M: Peak Signal-to-Noise Ratio taking into account Contrast
     Sensitivity Function (CSF) and between-coefficient contrast masking of
     DCT basis functions.

=== debian/watch ===
version=4

https://github.com/rolinh/vqmt/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
